using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace ChartPointsConnect
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.BackColor = System.Drawing.Color.White;
			this.chartControl1.ChartAreaShadow = false;
			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Syncfusion.Drawing.BrushInfoColorArrayList(new System.Drawing.Color[] {
																																																	 System.Drawing.Color.White,
																																																	 System.Drawing.Color.White}));
			this.chartControl1.Depth = 0;
			this.chartControl1.HidePartialLabels = false;
			this.chartControl1.Location = new System.Drawing.Point(8, 24);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.Rotation = 0;
			this.chartControl1.Series3D = false;
			this.chartControl1.Size = new System.Drawing.Size(512, 320);
			this.chartControl1.Spacing = 10F;
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "chartControl1";
			this.chartControl1.Tilt = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 390);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.chartControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();

			this.chartControl1.Legend.FilterItems += new LegendFilterItemsEventHandler(this.FilterLegend);
		}

		/// <summary>
		/// Initializes the ChartControl's data and sets the Chart type
		/// </summary>
		protected void InitializeChartData()
		{
			int numSeries = 3;
			int numPoints = 10;

			Random random = new Random();
			for(int i = 0; i < numSeries; i++)
			{
				ChartSeries series = this.chartControl1.Model.NewSeries("Series " + i);
				for(int j = 0; j < numPoints; j++)
				{
					series.Points.Add(j+1, (double)random.Next(400, 500));
				}
				
				series.Type = ChartSeriesType.Scatter;
				series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);
				series.Text = series.Name;
				this.chartControl1.Series.Add(series);
			}
		}

		/// <summary>
		/// Sets properties to customize the ChartControl's appearance
		/// </summary>
		protected void InitializeChartAppearance()
		{
			this.chartControl1.Series[0].Style.Border.Color = Color.FromArgb(100, Color.BlueViolet);
			this.chartControl1.Series[0].Style.Border.DashStyle = DashStyle.DashDotDot;
			this.chartControl1.Series[0].Style.Interior = new BrushInfo(Color.AntiqueWhite);
			this.chartControl1.Series[0].Style.Symbol.Color = Color.YellowGreen;

			this.chartControl1.Series[1].Style.Border.Color = Color.FromArgb(100, Color.Red);
			this.chartControl1.Series[1].Style.Border.DashStyle = DashStyle.DashDotDot;
			this.chartControl1.Series[1].Style.Symbol.Shape = ChartSymbolShape.InvertedTriangle;
			this.chartControl1.Series[1].Style.Interior = new BrushInfo(Color.YellowGreen);
			this.chartControl1.Series[1].Style.Symbol.Color = Color.AntiqueWhite;

			this.chartControl1.LegendPosition = ChartLegendPosition.Top;
			this.chartControl1.Legend.RepresentationType = ChartLegendRepresentationType.InvertedTriangle;
		}	
	

		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.TextOrientation = ChartTextOrientation.Center;
				
				args.Style.Symbol.Shape = ChartSymbolShape.InvertedTriangle;
				args.Style.Symbol.Size = new Size(15,15);
				args.Style.DisplayShadow = true;
			}
		}

		protected void FilterLegend(object sender, ChartLegendFilterItemsEventArgs args)
		{
			if(args.Items.Length == 3)
			{
				int legendCount = args.Items.Length;
				LegendItem[] filteredItems = new LegendItem[legendCount -1];
				int j = 0;
				for(int i =0; i <legendCount; i++ )
				{
					if(i != 2)
					{
						filteredItems[j] = args.Items[i];
						j++;
					}
				}
				args.Items = filteredItems;
			}
		}
	}
}
